/***
 * Sangjog CLI
 * Copyright(c) 2022 Hirak Santra
 */
class ProcessCheck {

    static nodeVersion = null;

    static setVersionMap() {
        const versionStr = process.versions.node;
        const versionList = versionStr.split('.');
        ProcessCheck.nodeVersion = {
            version: versionStr,
            major: Number(versionList[0]),
            minor: Number(versionList[1]),
            patch: Number(versionList[2])
        }
    }

    static setTitle() {
        try {
            process.title = 'sng ' + Array.from(process.argv).slice(2).join(' ');
        } catch (e) {
            process.title = 'sangjog development cmd';
        }
    }

    static checkNodeVersion() {
        const ver = ProcessCheck.nodeVersion.major;
        if(ver>=15){
            console.log(`=>Node.js version: ${process.version}`);
        } else if(ver>=12 && ver<15) {
            console.warn(`=>Node.js version: ${process.version} detected.\nPlease upgrade your node js.`);
        } else  {
            console.error(`=>Node.js version: ${process.version} detected.\nPlease upgrade your node js. Unable to run at this moment.`);
            process.exitCode = 3;
        }
    }

    static printWelcomeNote() {
        const color = "\x1b[35;1;1m%s\x1b[0m";
        console.log(color, `*********===========================*********`);
        console.log(color, `*********|                         |*********`);
        console.log(color, `*********|   Welcome to SANGJOG    |*********`);
        console.log(color, `*********|                         |*********`);
        console.log(color, `*********===========================*********`);
    }

    static check() {
        ProcessCheck.setVersionMap();
        ProcessCheck.checkNodeVersion();
        ProcessCheck.setTitle();
        ProcessCheck.printWelcomeNote();
    }

}

module.exports = ProcessCheck;