/***
 * Sangjog CLI
 * Copyright(c) 2022 Hirak Santra
 */
 'use strict';

const path = require('path');
const fs = require('fs');
const { option } = require('yargs');

class Utils {
    static cmdPath = process.cwd();

    static readDirectorySync(ROOT, folderPath, pathMatch, argFiles) {
        argFiles = argFiles || [];
        const files = fs.readdirSync(folderPath);
        for (const i in files){
            const fileName = files[i];
            const filePath = path.join(folderPath, fileName);
            const absPath = path.join(ROOT, filePath);
            if (fs.statSync(filePath).isDirectory()){
                Utils.readDirectorySync(ROOT, filePath, pathMatch, argFiles);
            } else {
                if(absPath.replaceAll('\\', '/').match(pathMatch)) {
                    argFiles.push(absPath); 
                }
            }
        }
        return argFiles;
    }

    static getFileListsInSrc(traceFolder, absFileList) {
        const filesPaths = [];
        if(absFileList && absFileList.length) {
            for(const fl of absFileList) {
                filesPaths.push(path.join(process.cwd(), fl))
            }
        }
        return filesPaths.concat(Utils.readDirectorySync(Utils.cmdPath, 'src' , `src/${traceFolder}`))
    }

    static getFolderName(name) {
        const text = name.replace(/([a-z])([A-Z])/g, '$1 $2').split(' ').join('-');
        return text.toLowerCase();
    }

    static getFileName(name) {

    }

    static throwArgErr() {
        throw Error(`Invalid arguments. Please put some valid arg.`);
    }

}

module.exports = Utils;